package nc.ui.gl.balancebooks;

import java.awt.BorderLayout;
import java.awt.Insets;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.HashMap;
import javax.swing.JFrame;
import nc.bs.logging.Logger;
import nc.ui.gl.balancebooks.BalancebookView;
import nc.ui.gl.balancebooks.BalancebooksModel;
import nc.ui.gl.balancebooks.ButtonKey;
import nc.ui.gl.cachefeed.BookCacheRequestFactory;
import nc.ui.gl.glreport.FctRunTestDlg;
import nc.ui.gl.glreportforufo.GlQryVOTrasTool;
import nc.ui.gl.remotecall.GlRemoteCallProxy;
import nc.ui.gl.tools.JTableTool;
import nc.ui.glpub.IParent;
import nc.ui.glpub.IUiPanel;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ButtonObject;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.ToftPanel;
import nc.ui.pub.linkoperate.ILinkQuery;
import nc.ui.pub.linkoperate.ILinkQueryData;
import nc.vo.bd.b54.GlorgbookVO;
import nc.vo.gl.glreport.GlQueryLinkUFOVO;
import nc.vo.gl.glreporttools.FunctionType;
import nc.vo.glcom.balance.GlQryFormatVO;
import nc.vo.glcom.balance.GlQueryVO;
import nc.vo.ntb.outer.NtbParamVO;
import nc.vo.pub.BusinessException;

public class ToftPanelView extends ToftPanel implements IUiPanel, ILinkQuery {

   private BalancebookView ivjBalancebook = null;
   private ButtonObject[] m_accbooksBns;
   private BalancebooksModel model = new BalancebooksModel();
   public IParent p_parent;
   public IUiPanel m_next;
   private boolean isUFODebug = false;


   public ToftPanelView() {
      this.initialize();
   }

   public void addListener(Object objListener, Object objUserdata) {
   }

   public void doQueryAction(GlQueryVO qryvo) {
   }

   private BalancebookView getBalancebookView() {
      if(this.ivjBalancebook == null) {
         try {
            this.ivjBalancebook = new BalancebookView(this);
            this.ivjBalancebook.setName("Balancebook");
            this.ivjBalancebook.setBounds(0, 0, 774, 418);
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjBalancebook;
   }

   public void updateButtons() {
      super.updateButtons();
   }

   protected void processKeyEvent(KeyEvent e) {
      super.processKeyEvent(e);
      if(e.getKeyCode() == 120 && e.isAltDown()) {
         FctRunTestDlg dlg = new FctRunTestDlg(this);
         dlg.showModal();
      }

   }

   public String getTitle() {
      return NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000505");
   }

   private void handleException(Throwable exception) {
   }

   private void initButtons() {
      this.m_accbooksBns = new ButtonObject[10];
      this.m_accbooksBns[0] = new ButtonObject(ButtonKey.bnQRY);
      this.m_accbooksBns[0].setTag(ButtonKey.bnQRY);
      this.m_accbooksBns[0].setName(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000176"));
      this.m_accbooksBns[0].setCode("查询");
      this.m_accbooksBns[1] = new ButtonObject(ButtonKey.bnDetail);
      this.m_accbooksBns[1].setTag(ButtonKey.bnDetail);
      this.m_accbooksBns[1].setName(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000178"));
      this.m_accbooksBns[1].setCode("明细");
      this.m_accbooksBns[2] = new ButtonObject(ButtonKey.bnTriAcc);
      this.m_accbooksBns[2].setTag(ButtonKey.bnTriAcc);
      this.m_accbooksBns[2].setName(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000490"));
      this.m_accbooksBns[2].setCode("总账");
      this.m_accbooksBns[3] = new ButtonObject(ButtonKey.bnAux);
      this.m_accbooksBns[3].setTag(ButtonKey.bnAux);
      this.m_accbooksBns[3].setName(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000491"));
      this.m_accbooksBns[3].setCode("辅助");
      this.m_accbooksBns[4] = new ButtonObject(ButtonKey.bnFresh);
      this.m_accbooksBns[4].setTag(ButtonKey.bnFresh);
      this.m_accbooksBns[4].setName(NCLangRes.getInstance().getStrByID("20021005", "UPP20021005-000477"));
      this.m_accbooksBns[4].setCode("刷新");
      this.m_accbooksBns[5] = new ButtonObject(ButtonKey.bnPrint);
      this.m_accbooksBns[5].setTag(ButtonKey.bnPrint);
      this.m_accbooksBns[5].setName(NCLangRes.getInstance().getStrByID("20020401", "UPP20020401-000100"));
      this.m_accbooksBns[5].setCode("打印");
      this.m_accbooksBns[6] = new ButtonObject(ButtonKey.bnListMultiOrg);
      this.m_accbooksBns[6].setTag(ButtonKey.bnListMultiOrg);
      this.m_accbooksBns[6].setName(NCLangRes.getInstance().getStrByID("20023005", "UPT20023005-000052"));
      this.m_accbooksBns[6].setCode("多主体列示");
      this.m_accbooksBns[7] = new ButtonObject(ButtonKey.bnReturn);
      this.m_accbooksBns[7].setTag(ButtonKey.bnReturn);
      this.m_accbooksBns[7].setName(NCLangRes.getInstance().getStrByID("20023005", "UPT20023005-000053"));
      this.m_accbooksBns[7].setCode("返回");
      this.m_accbooksBns[8] = new ButtonObject(NCLangRes.getInstance().getStrByID("20021005", "UPT200210036-000003"));
      this.m_accbooksBns[8].setTag(NCLangRes.getInstance().getStrByID("20021005", "UPT200210036-000003"));
      this.m_accbooksBns[8].setName(NCLangRes.getInstance().getStrByID("20021005", "UPT200210036-000003"));
      this.m_accbooksBns[8].setCode("科目转换");
      this.m_accbooksBns[9] = new ButtonObject(NCLangRes.getInstance().getStrByID("20021005", "UPT200210036-000004"));
      this.m_accbooksBns[9].setTag(NCLangRes.getInstance().getStrByID("20021005", "UPT200210036-000004"));
      this.m_accbooksBns[9].setName(NCLangRes.getInstance().getStrByID("20021005", "UPT200210036-000004"));
      this.m_accbooksBns[9].setCode("外文名称");
      this.setButtons(this.m_accbooksBns);
   }

   private void initialize() {
      try {
         this.setName("ToftpanelView");
         this.setLayout(new BorderLayout());
         this.setSize(774, 419);
         this.initButtons();
         this.add(this.getBalancebookView(), "Center");
      } catch (Throwable var2) {
         this.handleException(var2);
      }

      ToftPanelView.FormulaExeKeyAdapter formlKeyLstner = new ToftPanelView.FormulaExeKeyAdapter();
      this.getBalancebookView().getBalancebookUI().getMyTablePane().getTable().addKeyListener(formlKeyLstner);
   }

   public Object invoke(Object objData, Object objUserData) {
      return null;
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         ToftPanelView aToftpanelView = new ToftPanelView();
         exception.setContentPane(aToftpanelView);
         exception.setSize(aToftpanelView.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.pub.ToftPanel 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void nextClosed() {
   }

   public void onButtonClicked(ButtonObject bo) {
      try {
         for(int e = 0; e < this.m_accbooksBns.length; ++e) {
            if(bo.equals(this.m_accbooksBns[e])) {
               this.getBalancebookView().tackleBnsEvent(e);
               break;
            }
         }
      } catch (Exception var3) {
         Logger.error(var3.getMessage(), var3);
         this.showErrorMessage(var3.getMessage());
      }

   }

   public void removeListener(Object objListener, Object objUserdata) {
   }

   public void showMe(IParent parent) {
      parent.getUiManager().removeAll();
      parent.getUiManager().add(this, this.getName());
      if(parent instanceof ToftPanel) {
         ToftPanel map = (ToftPanel)parent;
         String e = ((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).getGlorgbookname();
         map.updateStatusBarAccountMsg(e);
      }

      try {
         GlRemoteCallProxy.callProxyAsyn(BookCacheRequestFactory.newAccountingBookQueryContextVO("20023005"));
      } catch (BusinessException var5) {
         Logger.error("取后台缓存", var5);
      }

      HashMap map1 = new HashMap();
      map1.put(this.getBalancebookView().getClass().getName(), this.getBalancebookView());

      try {
         JTableTool.INSTANCE.setColumnWidth(map1);
      } catch (Exception var4) {
         Logger.error(var4.getMessage(), var4);
      }

      this.p_parent = parent;
      this.getBalancebookView().setIParent(this.p_parent);
   }

   public boolean onClosing() {
      this.getBalancebookView().getBalancebookUI().showCol();
      HashMap map = new HashMap();
      map.put(this.getBalancebookView().getClass().getName(), this.getBalancebookView());

      try {
         JTableTool.INSTANCE.saveColumnWidth(map);
      } catch (Exception var3) {
         Logger.error(var3.getMessage(), var3);
      }

      return true;
   }

   public void doQueryAction(ILinkQueryData querydata) {
      Logger.info("进入方法 doQueryAction");

      try {
         GlQueryVO e = null;
         if(querydata.getUserObject() instanceof NtbParamVO) {
            e = GlQryVOTrasTool.convertNtbParamVO2GlQueryVO(querydata);
         } else {
            e = GlQryVOTrasTool.transferToQueryVO((GlQueryLinkUFOVO)querydata);
         }

         GlQryFormatVO formatvo = new GlQryFormatVO();
         formatvo.setShowZeroAmountRec(true);
         formatvo.setMultiOrgCombine(false);
         formatvo.setMultiCorpCombine(false);
         formatvo.setShowHasBalanceButZeroOccur(true);
         if(e.getFunname() != null && FunctionType.isBalanceFunction(e.getFunname())) {
            boolean iBalOrient = false;
            if(e.getOrientation() != null) {
               if(e.getOrientation().booleanValue()) {
                  formatvo.setBalanceOrient(1);
               } else {
                  formatvo.setBalanceOrient(2);
               }
            }
         }

         e.setFormatVO(formatvo);
         this.getBalancebookView().doQueryAction(e);
         Logger.info("     执行方法 doQueryAction 正常结束");
      } catch (Exception var5) {
         Logger.error(" 执行方法 doQueryAction 出错", var5);
      }

   }

   public class FormulaExeKeyAdapter implements KeyListener {

      public void keyPressed(KeyEvent e) {
         e.consume();
         if(e.getKeyCode() == 120 && e.isAltDown() && e.isControlDown()) {
            FctRunTestDlg dlg = new FctRunTestDlg(ToftPanelView.this);
            dlg.showModal();
         }

      }

      public void keyReleased(KeyEvent e) {
      }

      public void keyTyped(KeyEvent e) {
      }
   }
}
